<?php

/**
 * @author Florian Hochriegl, Florian@Hochriegl.de
 * @website www.gamers-congress.de
 * @version 2011040401
 * PayPal ruft dieses Script nach Abschluss einer Transaktion auf
 * das Script verifiziert die Anfrage dann auf korrektheit und gibt die Rechnung frei
 */
include("../global.php");
include($global['script_root'] . "/gc_payment/paymentFunctions.php");
global $gcConfig;
global $DB;

function logit($string) {
    //write to file
    $fh = fopen("logipn.txt", 'a'); //open file and create if does not exist
    fwrite($fh, $string . "\r\n"); //Just for spacing in log file
    fclose($fh); //close file
}

//To Make live uncomment line below with comment of live then comment the line above it
//add 'cmd' as required to get VERIFIED response

//Im Testbetrieb _POST zu _REQUEST ändern
logit("\r\n\r\n------------------------------------------------");
logit("Got new Request @ " . date("F j, Y, g:i a"));

$req = 'cmd=_notify-validate';
if ( $gcConfig['debugMode'] == FALSE )
	foreach ($_POST as $key => $value) {
		$value = urlencode(stripslashes($value));
		$req .= "&$key=$value";
		logit("POST Data: " . $key . " = " . $value);
}	
ELSE
	foreach ($_REQUEST as $key => $value) {
		$value = urlencode(stripslashes($value));
		$req .= "&$key=$value";
		logit("GET Data: " . $key . " = " . $value);
}



// setup headers for request to paypal
$header .= "POST /cgi-bin/webscr HTTP/1.1\r\n";
$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
if ( $gcConfig['debugMode'] == FALSE )
	$header .= "Host: www.paypal.com\r\n";	
ELSE
	$header .= "Host: www.sandbox.paypal.com\r\n";
$header .= "Connection: close\r\n";
$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";

//Open socket

//Endpunkt abhängig ob DEV System oder nicht
if ( $gcConfig['debugMode'] == FALSE )
		$fp = fsockopen('ssl://www.paypal.com', 443, $errno, $errstr, 30); //Live
ELSE
		$fp = fsockopen ('ssl://www.sandbox.paypal.com', 443, $errno, $errstr, 30);//TEst


if (!$fp) {// failed to connect to url
    logit("HTTP ERROR");
    logit($errstr);
} else {//successful connect to url

    logit("##### Header: ");
    logit("Header: " . $header);
    logit("complete Request: " . $req);

    fputs($fp, $header . $req); //send request

    while (!feof($fp)) { //while not end of file
        $res = fgets($fp, 1024); //get response
 	 $res = trim($res); //NEW & IMPORTANT

	 if ( $gcConfig['debugMode'] == FALSE )
				$payment_status = $_POST['payment_status'];
	ELSE
				$payment_status = $_REQUEST['payment_status'];
	
	if ( $gcConfig['debugMode'] == TRUE ) logit( "RES: $res");		

        if ( (strcmp($res, "VERIFIED") == 0) && (strcmp($payment_status,"Completed") == 0 ))  {

            //write to file

            logit("VERIFIED");

            $query = "SELECT * from gc_payment where id = $custom;";
            $row = $DB->queryrow( $query );
			
            $paymentAmount = $row['amount'];
            $PayPalGebuehren = number_format($paymentAmount * 0.019 + 0.35, 2);

            // Um Rundungsfehler zu vermeiden...
            if (abs(($paymentAmount + $PayPalGebuehren) - $mc_gross) < 0.50) {
                // Bezahlung korrekt

                $auslastung = eventAuslastung();
                if ($auslastung['frei'] > 0) {
                    activateByID($custom, "PayPal IPN Script");
                    logit("Aktiviere Zahlung nr. " . $custom);
                } else {
                    logit("Zahlung nr. " . $custom . " eingegangen, aber keien freien Plätze verfügbar! :(");
                }
            } else {
                // Bezahlung irgendwie fehlerhaft!
                logit("Zahlung für nr. $custom konnte nicht abgeschlossen werden, Zahlungsbetrag: \r\n
                       mc_gross:          $mc_gross \r\n
                       paymentAmount:     $paymentAmount \r\n
                       PayPalGebuehren:   $PayPalGebuehren \r\n
                       Differenz:         " . abs(($paymentAmount + $PayPalGebuehren) - $mc_gross) . "               \r\n");
            }
        } else if (strcmp($res, "INVALID") == 0) {
			// User per PM benachrichtigen
			global $CURRENT_USER;
			dotlan_send_msg($CURRENT_USER->id, $CURRENT_USER->id, 0, "Zahlung fehlgeschlagen", "Hallo User\n Bei Deiner Zahlung ist ein Fehler aufgetreten.\nSollte der Betrag von deinem PayPal Konto dennoch abgebucht worden sein benachrichtige Bitte die Organisation! \nDanke");
            
		
		if ( $gcConfig['debugMode'] == FALSE )
			logit("Sorry, Payment is " . $_POST['payment_status']);	//im Betrieb	 
		ELSE
			logit("Sorry, Payment is " . $_REQUEST['payment_status']); //zum testen

        }
    }

  fclose($fp);

}

?>
